Module Module1

    Public Sub Main()

        Dim strHTMFileName As String
        Dim strTextFileName As String
        Dim intHTMFileNbr As Integer
        Dim intTextFileNbr As Integer

        Dim strBuffer As String = ""
        Dim strCurrentChar As String
        Dim blnTagPending As Boolean

        Dim intX As Integer
        Dim intBytesRemaining As Integer
        Dim intCurrentBufferSize As Integer
        Const intMAX_BUFFER_SIZE As Integer = 10000

        strHTMFileName = My.Application.Info.DirectoryPath & "\Files_Lesson1.htm"
        strTextFileName = My.Application.Info.DirectoryPath & "\TestOut.txt"

        Console.WriteLine("Opening files ...")

        'Open the input file ...
        intHTMFileNbr = FreeFile()
        FileOpen(intHTMFileNbr, strHTMFileName, OpenMode.Binary, OpenAccess.Read)

        ' If the file we want to open for output already exists, delete it ...
        If Dir(strTextFileName) <> "" Then
            Kill(strTextFileName)
        End If

        ' Open the output file ...
        intTextFileNbr = FreeFile()
        FileOpen(intTextFileNbr, strTextFileName, OpenMode.Binary, OpenAccess.Write)

        ' Initialize the "bytes remaining" variable to the length of the input file ...
        intBytesRemaining = LOF(intHTMFileNbr)

        ' Set up a loop which will process the file in "chunks" of 10,000 bytes at a time.
        ' We will keep track of how many bytes we have remaining to process, and
        ' the loop will continue as long as there are bytes remaining.

        Do While intBytesRemaining > 0

            Console.WriteLine("Processing 'chunk' ...")

            ' Note: The "buffer" is simply a string variable into which the "current
            ' chunk" of the file will be read.

            ' Set the current buffer size to be either the maximum size (10,000) as
            ' long as there are least 10,000 bytes remaining. If there are less (as
            ' there would be the last time through the loop), set the buffer size
            ' equal to the number of bytes remaining.

            If intBytesRemaining >= intMAX_BUFFER_SIZE Then
                intCurrentBufferSize = intMAX_BUFFER_SIZE
            Else
                intCurrentBufferSize = intBytesRemaining
            End If

            ' Because the FileGet function relies on the size of the string variable (the
            ' "buffer") into which the data will be read to know how many bytes to read
            ' from the file, we fill the buffer string variable with a number of blank
            ' spaces - where the number of blank spaces was determined in the statement
            ' above.

            strBuffer = New String(" ", intCurrentBufferSize)

            ' The FileGet function now reads the next chunk of data from the input file
            ' and stores it in the strBuffer variable.

            FileGet(intHTMFileNbr, strBuffer)

            ' The For loop below now processes the current chunk of data character by
            ' character, writing out only the characters that are NOT enclosed in the
            ' HTML tags (i.e., it is skipping every character between a pair of angle
            ' brackets "<" and ">") ...

            For intX = 1 To intCurrentBufferSize
                strCurrentChar = Mid(strBuffer, intX, 1)
                Select Case strCurrentChar
                    Case "<"
                        blnTagPending = True
                    Case ">"
                        blnTagPending = False
                    Case Else
                        If Not blnTagPending Then
                            ' The current character is outside of the tag brackets, so
                            ' write it out ...
                            FilePut(intTextFileNbr, strCurrentChar)
                        End If
                End Select
            Next

            ' Adjust the "bytes remaining" variable by subtracting the current buffer size
            ' from it ...
            intBytesRemaining = intBytesRemaining - intCurrentBufferSize
        Loop

        Console.WriteLine("Closing files ...")

        ' Close the input and output files ...
        FileClose(intHTMFileNbr)
        FileClose(intTextFileNbr)

        Console.WriteLine("Done.")
        Console.ReadLine()
    End Sub

End Module